package ink.wgink.module.examine.dao.question;

import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.exceptions.SearchException;
import ink.wgink.interfaces.init.IInitBaseTable;
import ink.wgink.module.examine.pojo.dtos.question.QuestionTypeQuestionDTO;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @Description: 试题类型与试题
 * @Author: WenG
 * @Date: 2022/5/15 17:16
 * @Version: 1.0
 **/
@Repository
public interface IQuestionTypeQuestionDao extends IInitBaseTable {

    /**
     * 新增
     *
     * @param params
     * @throws SaveException
     */
    void save(Map<String, Object> params) throws SaveException;

    /**
     * 删除
     *
     * @param params
     * @throws RemoveException
     */
    void delete(Map<String, Object> params) throws RemoveException;

    /**
     * 试题类型ID列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<String> listQuestionTypeId(Map<String, Object> params) throws SearchException;

    /**
     * 试题类型列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<QuestionTypeQuestionDTO> list(Map<String, Object> params) throws SearchException;
}
